from datetime import datetime, timedelta
from pathlib import Path

from airflow import DAG
from airflow.operators.bash import BashOperator
from airflow.operators.empty import EmptyOperator
from airflow.operators.python import BranchPythonOperator
from pydantic.dataclasses import dataclass

from research.config import args, dag_config
from research.dags.snapshot_sensor import (
    wait_for_mediawiki_page_snapshot,
    wait_for_mediawiki_pagelinks_snapshot,
    wait_for_mediawiki_private_linktarget_snapshot,
    wait_for_mediawiki_project_namespace_map_snapshot,
    wait_for_mediawiki_redirect_snapshot,
    wait_for_wikidata_item_page_link_snapshot,
)
from wmf_airflow_common.operators.spark import SparkSqlOperator, SparkSubmitOperator
from wmf_airflow_common.templates.time_filters import filters


@dataclass(frozen=True)
class DagProperties(dag_config.BaseProperties):
    # Dag configuration
    alerts_email: str = "research-engineering-alerts@lists.wikimedia.org"
    conda_env: str = dag_config.artifact("research_datasets.tgz")
    sla: timedelta = timedelta(days=3)
    # Pipeline arguments
    pipeline_args: args.ArticletopicsPipelineRun = args.ArticletopicsPipelineRun(
        mediawiki_snapshot="{{ data_interval_start | to_ds_month }}",
        wikidata_snapshot="{{data_interval_start | start_of_current_week | to_ds}}",
        wikis=None,
        model_url="https://analytics.wikimedia.org/published/wmf-ml-models/articletopic/outlink/20221111111111/model.bin",
        max_files_per_wiki=8,
        output=Path(dag_config.hdfs_temp_directory) / "article_topics",
    )
    article_topics_table: str | None = None
    # Spark configuration
    driver_cores: int = 4
    driver_memory: str = "8G"
    executor_cores: int = 4
    executor_memory: str = "12G"
    executor_memory_overhead: str = "4G"
    max_executors: int = 98
    shuffle_partitions: int = 4096


props = DagProperties.from_variable("article_topics")
default_args = dag_config.default_args | {"email": props.alerts_email, "sla": props.sla}
pipeline_args = props.pipeline_args


with DAG(
    dag_id="article_topics",
    schedule="@monthly",
    start_date=datetime(2024, 4, 1),
    user_defined_filters=filters,
    default_args=default_args,
    tags=["research", "article-topics"],
    catchup=True,
) as dag:
    wait_for_data = (
        wait_for_mediawiki_page_snapshot(pipeline_args.mediawiki_snapshot),
        wait_for_mediawiki_pagelinks_snapshot(pipeline_args.mediawiki_snapshot),
        wait_for_mediawiki_private_linktarget_snapshot(pipeline_args.mediawiki_snapshot),
        wait_for_mediawiki_redirect_snapshot(pipeline_args.mediawiki_snapshot),
        wait_for_wikidata_item_page_link_snapshot(pipeline_args.wikidata_snapshot),
        wait_for_mediawiki_project_namespace_map_snapshot(pipeline_args.mediawiki_snapshot),
    )

    spark_conf = {
        "spark.hadoop.fs.permissions.umask-mode": "022",
        "spark.sql.sources.partitionOverwriteMode": "dynamic",
        "spark.sql.shuffle.partitions": props.shuffle_partitions,
        "spark.sql.adaptive.enabled": "true",
        # To avoid timeout errors when the nodes are downloading
        # the model file added to the spark context.
        "spark.network.timeout": "1200s",
    }
    compute_article_topics = SparkSubmitOperator.for_virtualenv(
        task_id="compute_article_topics",
        virtualenv_archive=props.conda_env,
        entry_point="bin/research_datasets_pipelines.py",
        application_args=["articletopics.pipeline.run", pipeline_args.json()],
        driver_cores=props.driver_cores,
        driver_memory=props.driver_memory,
        executor_cores=props.executor_cores,
        executor_memory=props.executor_memory,
        executor_memory_overhead=props.executor_memory_overhead,
        max_executors=props.max_executors,
        conf=spark_conf,
    )

    oldest_snapshot_path = (
        pipeline_args.output
        / "snapshot={{ data_interval_start | subtract_months(4) | to_ds_month }}"
    )
    drop_oldest_snapshot = BashOperator(
        task_id="drop_oldest_snapshot",
        bash_command=f"hdfs dfs -rm -f -R {oldest_snapshot_path}",
    )

    should_create_table = BranchPythonOperator(
        task_id="should_create_table",
        python_callable=lambda: ("create_table_if_not_exists", "repair_table")
        if props.article_topics_table
        else "no_op",
    )

    create_table_if_not_exists = SparkSqlOperator(
        task_id="create_table_if_not_exists",
        sql=f"""
CREATE TABLE IF NOT EXISTS {props.article_topics_table} (
    pid_from         BIGINT        COMMENT 'id of the page',
    qid_from         STRING        COMMENT 'wikidata QID of the page',
    outlinks         STRING        COMMENT 'all target links from this page, separated by space',
    embedding        ARRAY<FLOAT>  COMMENT 'embedding generated by the outlink topic model',
    predicted_labels ARRAY<STRUCT<
            label: STRING,
            probability: FLOAT
        >
    >                              COMMENT 'predicted topic labels'              
)
COMMENT 'Article topic labels and embeddings using the outlinks model'
PARTITIONED BY (
    snapshot STRING COMMENT 'mediawiki snapshot',
    wiki_db  STRING COMMENT 'the wiki project'
)
STORED AS PARQUET
LOCATION '{pipeline_args.output}'
""",
    )
    repair_table = SparkSqlOperator(
        task_id="repair_table", sql=f"MSCK REPAIR TABLE {props.article_topics_table}"
    )
    create_table_if_not_exists >> repair_table

    no_op = EmptyOperator(task_id="no_op")

    (
        wait_for_data
        >> compute_article_topics
        >> drop_oldest_snapshot
        >> should_create_table
        >> [create_table_if_not_exists, no_op]
    )
